#ifndef BOOK_COMMAND_HPP
#define BOOK_COMMAND_HPP

#include "Category.h"

#include <functional>
#include <cassert>


class SceneNode;

struct Command
{
												Command();

	std::function<void(SceneNode&, float)>	action;
	unsigned int							category;
};

template <typename GameObject, typename Function>
std::function<void(SceneNode&, float)> derivedAction(Function fn)
{
	return [=] (SceneNode& node, float dt)
	{
		// Check if cast is safe
		assert(dynamic_cast<GameObject*>(&node) != nullptr);

		// Downcast node and invoke function on it
		fn(static_cast<GameObject&>(node), dt);
	};
}

#endif // BOOK_COMMAND_HPP
