#include "DataTables.h"
#include "Snake.h"
#include "Pickup.h"
#include "Obstacle.h"


// For std::bind() placeholders _1, _2, ...
using namespace std::placeholders;


std::vector<PickupData> initializePickupData()
{
	std::vector<PickupData> data(Pickup::TypeCount);

	data[Pickup::Apple].model = Models::Apple;
	data[Pickup::Apple].action = [](Snake& a)
	{
		a.addPoints(40);
		a.grow();
	};

	data[Pickup::Banana].model = Models::Banana;
	data[Pickup::Banana].action = [](Snake& a)
	{
		a.addPoints(80);
		a.grow();
	};

	data[Pickup::ExtraLive].model = Models::ExtraLive;
	data[Pickup::ExtraLive].action = std::bind(&Snake::addLive, _1);

	return data;
}

std::vector<ObstacleData> initializeObstacleData()
{
	std::vector<ObstacleData> data(Obstacle::TypeCount);

	data[Obstacle::Palm].modelID = Models::GenericPalm;
	data[Obstacle::Palm].action = std::bind(&Snake::destroy, _1);

	return data;
}
