#ifndef BOOK_DATATABLES_HPP
#define BOOK_DATATABLES_HPP

#include "ResourceIdentifiers.h"

#include <vector>
#include <functional>


class Snake;
class Pickup;

struct Direction
{
	Direction(float angle, float distance)
	: angle(angle)
	, distance(distance)
	{
	}

	float angle;
	float distance;
};

//struct SnakeData
//{
//	int								hitpoints;
//	float							speed;
//	Textures::ID					texture;
//	sf::Time						fireInterval;
//	std::vector<Direction>			directions;
//};

struct PickupData
{
	Models::ID model;
	std::function<void(Snake&)>	action;
};

struct ObstacleData
{
	Models::ID modelID;
	std::function<void(Snake&)>	action;
};

std::vector<PickupData>		initializePickupData();
std::vector<ObstacleData>	initializeObstacleData();

#endif // BOOK_DATATABLES_HPP
