#ifndef BOOK_ENTITY_HPP
#define BOOK_ENTITY_HPP

#include "SceneNode.h"

class Entity : public SceneNode
{
public:
	explicit Entity(int hitpoints);

	void setVelocity(DirectX::XMFLOAT3 velocity);
	void setVelocity(float vx, float vy, float vz);
	void accelerate(DirectX::XMFLOAT3 velocity);
	void accelerate(float vx, float vy, float vz);
	DirectX::FXMVECTOR getVelocity() const;

	int getHitpoints() const;
	void repair(int points);
	void damage(int points);
	void destroy();
	bool isDestroyed() const override;

protected:
	void move(DirectX::XMFLOAT3 translate);

protected:
	void updateCurrent(float dt, CommandQueue& commands) override;

private:
	DirectX::XMFLOAT3 mVelocity;
	int mHitpoints;
};

#endif // BOOK_ENTITY_HPP
