#ifndef BOOK_RESOURCEHOLDER_HPP
#define BOOK_RESOURCEHOLDER_HPP

#include <map>
#include <string>
#include <memory>
#include <stdexcept>
#include <cassert>

#include <d3d11.h>
#include <Model.h>
#include <Effects.h>
#include "ResourceIdentifiers.h"


class ModelHolder
{
	public:
		ModelHolder(ID3D11Device* d3dDevice, DirectX::IEffectFactory& fxFactory);

		void load(Models::ID id, const std::wstring& filename);

		DirectX::Model& get(Models::ID id);
		const DirectX::Model& get(Models::ID id) const;


	private:
		void insertResource(Models::ID id, std::unique_ptr<DirectX::Model> resource);


	private:
		ID3D11Device* md3dDevice;
		DirectX::IEffectFactory* mfxFactory;

		std::map<Models::ID, std::unique_ptr<DirectX::Model>>	mResourceMap;
};

//#include "ResourceHolder.inl"
#endif // BOOK_RESOURCEHOLDER_HPP
