#pragma once
#include "Entity.h"

#include "Command.h"
#include "ModelHolder.h"

#include <chrono>

class Snake;

class Pickup : public Entity
{
public:
	enum Type
	{
		Apple,
		Banana,
		ExtraLive,
		TypeCount
	};


public:
	Pickup(Type type, ModelHolder& models);

	virtual unsigned int getCategory() const;
	virtual BoundingOrientedBox	getBoundingRect() const;
	bool isMarkedForRemoval() const override;

	void apply(Snake& player) const;


protected:
	void updateCurrent(float dt, CommandQueue& commands) override;
	void drawCurrent(ID3D11DeviceContext* dc, const Camera& camera, const CommonStates& states) const override;
	void drawBoundingRect(ID3D11DeviceContext * deviceContext, const Camera & camera, const DirectX::CommonStates & states) const override;

private:
	bool mIsMarkedForRemoval;

	Type mType;
	DirectX::Model* mModel;

	std::chrono::seconds mLiveTime;
	std::chrono::time_point<std::chrono::high_resolution_clock> mCreateTime;
};

