#pragma once
#include "SceneNode.h"

#include <string>

#include <SpriteFont.h>

class TextNode :
	public SceneNode
{
public:
	TextNode(SpriteFont* font);
	TextNode(SpriteFont* font, int x, int y);
	virtual ~TextNode();

	unsigned int getCategory() const override;
	bool isMarkedForRemoval() const override;

	void setPosition(int x, int y);
	void setOrigin(int x, int y);
	void setText(std::wstring text);

	std::wstring getText();

private:
	void updateCurrent(float dt, CommandQueue& commands) override;
	void drawCurrent(ID3D11DeviceContext* dc, const Camera& camera, const CommonStates& states) const override;

private:
	bool mIsMarkedForRemoval;

	DirectX::XMFLOAT2 mPosition;
	DirectX::XMFLOAT2 mOrigin;
	std::wstring mText;

	SpriteFont* m_font;
};
