#include "Transforms.h"

using namespace DirectX;

Transforms::Transforms()
	: mTranslate(0.0f, 0.0f, 0.0f)
	, mRotate(0.0f, 0.0f, 0.0f)
	, mScale(1.0f, 1.0f, 1.0f)
{
}

Transforms::Transforms(DirectX::FXMMATRIX& world)
	: mTranslate(0.0f, 0.0f, 0.0f)
	, mRotate(0.0f, 0.0f, 0.0f)
	, mScale(1.0f, 1.0f, 1.0f)
{
}

Transforms::Transforms(DirectX::XMFLOAT3 translate, DirectX::XMFLOAT3 rotate, DirectX::XMFLOAT3 scale)
	: mTranslate(translate)
	, mRotate(rotate)
	, mScale(scale)
{
}

DirectX::FXMMATRIX Transforms::World() const
{
	XMMATRIX I = XMMatrixIdentity();
	XMMATRIX scale = XMMatrixScalingFromVector(XMLoadFloat3(&mScale));
	XMMATRIX rotatex = XMMatrixRotationX(mRotate.x);
	XMMATRIX rotatey = XMMatrixRotationY(mRotate.y);
	XMMATRIX rotatez = XMMatrixRotationZ(mRotate.z);
	XMMATRIX translate = XMMatrixTranslationFromVector(XMLoadFloat3(&mTranslate));

	XMMATRIX world = I * scale * rotatex * rotatey * rotatez * translate;
	return world;
}